<template>
  <div>
    <Modal v-model="showModal" width="1200" class="modal-footer-none">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <!--内容-->
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="formId" :label-width="80" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item label="样品名称:" class="search-item">
                <Input v-model="formObj.name" placeholder="请输入样品名称" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item label="样品编号:" class="search-item">
                <Input v-model="formObj.code" placeholder="请输入样品编号" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn" style="margin-left: -10px">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                      @on-result-change="_btnClick"></btn-list>
          </Col>
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :get-page="getPage"
                        :icon-msg="iconMsg" select-data @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id)">{{scope.row[item.key]}}</a></div>
                  <div v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </div>
                  <div v-else-if="item.key==='jobOut'">
                     {{scope.row[item.key]===1?'是':'否'}}
                  </div>
                  <span v-else-if="item.key==='singleJudge'">
                     {{ scope.row[item.key]===undefined?'':scope.row[item.key].display }}
                   </span>
                  <div v-else-if="item.key==='testValue'">
                    <el-input
                      v-model="scope.row.testValue"
                      size="medium"
                      placeholder="请输入检测结果"
                      @blur="_handleTestValueEdit(scope.row.id,scope.row.testValue)"
                    />
                  </div>
                  <div v-else-if="item.key==='progress'">
                    {{scope.row.progress.display}}
                  </div>
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult"></modal-footer>
      </div>
    </Modal>
    <fillout ref="fillout"  @on-result-change="_page"></fillout>
    <decide ref="decide" @on-result-change="_page"></decide>
    <docimasy ref="docimasy"  @on-result-change="_page"></docimasy>
  </div>
</template>
<script>
import { meterItem } from '../../../api'
import fillout from './DetectionValue'
import decide from './Judge'
import docimasy from './docimasy'
export default {
  components: {
    fillout,
    decide,
    docimasy
    // FoodSampleGovernDetail,
    // CopyModal,
    // FoodSampleGovernLYEdits
  },
  data() {
    return {
      currentComponent: '',
      // btn: [
      //   {type: 'success', id: '', name: '添加', componentName: 'FoodSampleGovernEdit'},
      //   {id: 'food-gov-sample-batch-add', name: '批量添加', componentName: 'FoodSampleGovernBatchAdd'},
      //   {id: '', name: '导入样品', componentName: 'FoodImportSample'},
      //   {id: '', name: '导入检测项目', componentName: 'RelItem'},
      //   {id: '', name: '导入检测项目包', componentName: 'RelItemPackage'},
      //   {id: '', name: '复制历史样品检测项目', componentName: 'CopyHisItem'},
      //   {id: '', name: '删除'},
      // ],
      footerList: [
        { name: '取消', type: '' },
        { name: '确定', type: 'primary' }
      ],
      iconMsg: [
        // { type: 'md-checkmark', id: '', name: '完成' }
      ],
      btn: [
        {
          type: 'success',
          id: 'meter-person-item-task-manage-input',
          name: '填写检测值'
        },
        {
          type: 'success',
          id: 'meter-person-item-task-manage-judge',
          name: '判定'
        },
        {
          type: 'success',
          id: 'meter-person-item-task-manage-condition',
          name: '检定条件'
        }
      ],
      options: [
        {
          name: '检定'
        },
        {
          name: '校准'
        },
        {
          name: '外观检查'
        }
      ],
      formId: 'meterReviewSampleManageFormId',
      showModal: false,
      searchOpen: false,
      modalTitle: '管理样品',
      selectIds: [],
      selectData: [],
      getPage: {},
      pageColumns: [
        // { title: '样品编号', key: 'code', detail: true, width: 120 },
        { title: '检定项目', key: 'name', width: 180 },
        { title: '比较符', key: 'compare', width: 100 },
        { title: '限量值', key: 'limitValue', width: 140 },
        { title: '检测值', key: 'testValue', width: 140 },
        { title: '单项判定', key: 'singleJudge', width: 140 },
        { title: '进度', key: 'progress', width: 110 }
      ],
      dateList: [],
      sampleId: '',
      formObj: {
        sampleId: undefined,
        name: undefined,
        code: undefined,
        type: undefined
      }
    }
  },
  computed: {
    tableHeight: function() {
      return this.$tableHeight('tableModal')
    }
  },
  methods: {
    _dateChange(data) {
      this.formObj.ctimeBegin = data[0]
      this.formObj.ctimeEnd = data[1]
    },
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '确定':
          this._cancel()
          break
      }
    },
    _cancel() {
      this.showModal = false
      this.$emit('on-result-change')
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '检定条件':
            this._docimasy()
            break
          case '判定':
            this._judge()
            break
          case '完成':
            this._testEnd()
            break
          case '填写检测值':
            // this._handleTestValueEdit()
            this._detectionValue()
            break
          case '导入检测项目':
            this._importItem()
            break
          case '导入检测项目包':
            this._importItemPackage()
            break
          case '复制历史样品检测项目':
            this._copyHisItem()
            break
          case '删除':
            this._deleteSelected()
            break
        }
      })
    },
    _docimasy() {
      this.$refs.docimasy._open(this.sampleId)
    },
    _detectionValue() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.fillout._open(this.selectIds)
      }
    },
    _judge() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.decide._open(this.selectIds)
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            localStorage.setItem('type', data.type)
            if (data.type === 2) {
              this._editLY(data.id) // 粮油的编辑页
            } else {
              this._editModal(true, data.id)
            }
            break
          case '复制':
            this._copy(data.id, data.type)
            break
          case '删除':
            this._deleteById(data.id)
            break
          case '检测项目':
            this._itemDetail(data.id)
            break
        }
      })
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectData':
          const selectIds = []
          for (let i = 0; i < data.length; i++) {
            selectIds.push(data[i].id)
          }
          this.selectIds = selectIds
          this.selectData = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _open(id) {
      this.formObj.sampleId = id
      this.sampleId = id
      this.showModal = true
      this._page()
    },

    _testEnd() {
      if (this.selectIds.length === 0) {
        this.$Message.success('请选择完成检测的项目')
        return false
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定完成检测数据的填写了吗？',
        onOk: () => {
          this._testItemEnd(this.selectIds)
        }
      })
    },
    _testItemEnd: async function() {
      const result = await meterItem.testEnd({
        ids: this.selectIds,
        sampleId: this.formObj.sampleId
      })
      if (result) {
        await this._page()
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      this.selectIds = []
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterItem.pageTest(this.formObj)
      console.log('result', result)
      if (result) {
        this.getPage = result
        this.$refs.pageTable._hideLoading()
      }
    },
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this.$store.dispatch('FoodSample/deleteByIds', ids).then(() => {
            this._resultChange('删除成功!')
          })
        }
      })
    },
    _deleteById(id) {
      // 删除一条记录
      this._deleteByIds([id])
    },
    _deleteSelected() {
      // 批量删除
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this._deleteByIds(ids, '确定删除 ' + ids.length + ' 条记录？')
      }
    },
    _detailModal(id) {
      this.currentComponent = 'FoodSampleGovernDetail'
      this.$nextTick(function() {
        this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
          this.$refs.refModal._open(this.$store.state.FoodSample.governModel)
        })
      })
    },
    _editModal(edit, id) {
      this.currentComponent = 'FoodSampleGovernEdit'
      this.$nextTick(function() {
        if (edit) {
          this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
            this.$refs.refModal._open(
              this.$store.state.FoodSample.governModel,
              this.contractId
            )
          })
        } else {
          this.$refs.refModal._open('', this.contractId)
        }
      })
    },
    _editLY(id) {
      // 粮油的编辑
      this.currentComponent = 'FoodSampleGovernLYEdit'
      this.$nextTick(function() {
        this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
          this.$refs.refModal._open(
            this.$store.state.FoodSample.governModel,
            this.contractId
          )
        })
      })
    },
    _search() {
      this._page()
    },
    _searchParams() {
      const data = this.$serialize('search-sample-govern')
      return this.$extend(data, this.pageParams)
    },
    _resultChange(msg) {
      if (this.$store.state.FoodSample.success) {
        this._page()
        this.$Message.success(msg)
      }
    },
    _copy(sampleId, type) {
      this.$refs.refModal._open(sampleId, type)
    },
    // 导入样品
    _importSample() {
      const data = {
        importUrl: '/food/v1/sample/government/import_' + this.contractId,
        downloadUrl: '/food/v1/excel/template/FoodSampleGovernment',
        title: '导入'
      }
      this.$refs.refModal._open(data)
    },
    // 导入检测项目
    _importItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds, this.selectData[0])
      }
    },
    _subpackageSample() {
      if (this.selectData.length === 0) {
        this.$Message.warning('请至少选中一条样品进行分包！')
        return false
      } else {
        for (let i = 0; i < this.selectData.length; i++) {
          if (this.selectData[i].jobOut === 1) {
            this.$Message.warning(
              '样品编号为' +
                this.selectData[i].code +
                '已经分包了，请选择未分包的样品！'
            )
            return false
          }
        }
        this._subpackage(this.selectIds)
      }
    },

    _importItemPackage() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds, 'batch-rel-package-item')
      }
    },
    _copyHisItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds)
      }
    },
    _itemDetail(id) {
      this.$refs.foodItem._open(id)
    },
    _operationRecord(id) {
      // 操作日志
      this.$refs.recordModal._open(id)
    },
    // 单个填写检测值
    _handleTestValueEdit: async function(id, testValue) {
      if (testValue !== '' && undefined !== testValue) {
        const data = {}
        data.itemIds = id
        data.testValue = testValue
        const result = await meterItem.testValue(data)
        if (result) {
          this.$Message.success('保存成功')
          await this._page()
        } else {
          this.$Message.error('保存失败')
        }
      }
    }
  }
}
</script>
